Description

Nowadays, markdown is much more used and known compared with textile. Also, in Redmine, Markdown has better support.

My proposal is to change the default setting from textile to markdown.

Related issues:

Related to Redmine - Patch #35952: Explicitly specify text formatting in the ... Closed

Related to Redmine - Feature #37365: Allow users to choose textile or markdow... Closed

Blocked by Redmine - Patch #36807: Remove CommonMark experimental flag and ma... Closed

Associated revisions

Revision 21897 - 2022-10-04 21:19 - Marius BĂLTEANU

Make common_mark the default text formatting for new installations (#34863).

Revision 21962 - 2022-11-28 23:33 - Marius BĂLTEANU

Fix failing test by removing bad assertion (#34863).

Revision 22399 - 2023-10-29 13:50 - Marius BĂLTEANU

Fixes failing system test caused by unavailable Underline button in CommonMark (#34863).

Revision 22400 - 2023-10-29 15:54 - Marius BĂLTEANU

Merged r22399 from trunk to 5.1-stable (#34863).

History

#1 - 2021-03-09 09:08 - Marius BĂLTEANU

- Subject changed from Change default text formatter for new installation from textile to markdown to Change default text formatter for new

installations from textile to markdown

#2 - 2021-03-10 07:19 - Mizuki ISHIKAWA

+1

Since it is not possible to change the text formatter setting for each project in Redmine, there is also the problem that it is difficult to change to

Markdown once you start using it with Textile.

I think it's better to use the commonly used Markdown as the default.

#3 - 2021-03-10 09:22 - beko akabeko

+1

Markdown is used in many text systems (GitHub, Slack, ...etc). Therefore, setting this as the default will improve portability.

#4 - 2021-03-15 10:22 - Moritz Poldrack

+1

Since it is not possible to change the text formatter setting for each project in Redmine, there is also the problem that it is difficult to change to

Markdown once you start using it with Textile.

I think it's better to use the commonly used Markdown as the default.
 it's possible using grep, sed, and pandoc. but it's a real PITA

#5 - 2021-03-15 14:08 - Bernhard Rohloff

+1

Markdown is also the better choice for the 'average guy' and has easier to adopt by non IT people.

#6 - 2021-03-16 10:37 - Go MAEDA

- File 0001-Explicitly-specify-text-formatting-in-the-test-suite.patch added

- File 0002-Change-the-default-text-formatting-to-Markdown.patch added

- File 0003-Change-the-text-formatting-of-fixtures-to-Markdown.patch added

The attached patches change the default text formatting to Markdown.

#7 - 2021-03-28 08:22 - Go MAEDA

- Target version set to 5.0.0

Setting the target version to 5.0.0.

#8 - 2021-10-03 21:26 - Marius BĂLTEANU

- Target version changed from 5.0.0 to Candidate for next major release

I think the best option is to change to CommonMark when we will remove the experimental flag.

#9 - 2021-12-30 09:39 - Go MAEDA

- Related to Patch #35952: Explicitly specify text formatting in the test suite added

#10 - 2022-01-22 11:15 - Marius BĂLTEANU

Now that CommonMark feature was added to the core, for sure we should not set the old Markdown as default, but at the same time, it's pity to keep

textile as default.

Maybe is better to set CommonMark even is it marked as experimental? Or even remove the experimental flag?

#11 - 2022-03-22 08:15 - Go MAEDA

- Target version changed from Candidate for next major release to 6.0.0

#12 - 2022-03-29 10:41 - Go MAEDA

- Target version changed from 6.0.0 to 5.1.0

#13 - 2022-03-29 10:43 - Go MAEDA

- Blocked by Patch #36807: Remove CommonMark experimental flag and mark as deprecated the RedCarpet Markdown added

#14 - 2022-05-17 00:39 - Marius BĂLTEANU

- Subject changed from Change default text formatter for new installations from textile to markdown to Change default text formatter for new

installations from textile to common_mark

#15 - 2022-05-17 23:30 - Marius BĂLTEANU

- File 0001-Set-common_mark-as-default-text-formatting.patch added

Here is the patch to set common_mark the default formatter.

#16 - 2022-05-31 11:08 - Holger Just

When changing the default formatter, we should ensure that the previous setting is definitely preserved. Often, the setting is stored in the database,

but not necessarily. It can also be used with just the default from settings.yml. Changing the setting just there will silently change the global text

formatting setting during an upgrade.

As such, I believe we need a migration here that strictly adds the current setting as a database entry before changing this (rather important) default

setting. This must take several cases into account:

Upgrade - An existing Redmine with a text_formatting setting stored in the database
Upgrade - An existing Redmine with the default text_formatting from settings.yml without an explicitly stored setting

New Setup - An initial setup with an empty database.

A possible solution would be to perform the following two changes:

Add a new migration which sets the text_formatting setting in the database to the static value textile, only if there is no existing entry in the

database.

This should take care of the upgrade paths to retain the previous (default or adapted) setting regardless of how we change the default in

settings.yml.

Update an existing old migration to explicitly set the common_mark setting to the database in the same commit as the update to the settings.yml.

E.g. the source:trunk/db/migrate/017_create_settings.rb migration.

This should take care of the initial setup. As the new default setting is set to the DB early, the later new migration will no nothing in this case.

Existing installation won't re-apply the changed initial migration.

As for the timeline, please let me quote my comment from #36807#note-5:

The default formatter is only relevant for new installations. I have no strong opinion on whether this requires a major release (6.0.0) or minor

release (5.1.0). I have a slight hunch that it might be surprising in a patch release (5.0.x).

#17 - 2022-06-25 19:49 - Marius BĂLTEANU

- File 0001-Set-common_mark-as-default-text-formatting.patch added

Thanks Holger for your valuable feedback, I wasn't aware that the default settings are not stored in the db from the beginning.

I think the attached patch should do the trick:

1. Setting text_formatting already stored in the database: it won't do anything and this is the expected behaviour

2. Setting text_formatting doesn't exist in the database: it will run the migration and it will persist the Setting.text_formatting in the db instead of the

static textile value. That means for existing installations it will insert textile most probably (if the setting.yml file wasn't manually changed) and for new

installations, it will insert @common_mark.

What do you think? Am I missing any case?

#18 - 2022-07-13 12:12 - Jens Krämer

In an existing installation without a setting in the database, when applying the patch and then running the migration, Setting.text_formatting will

already return common_mark with the changed default in settings.yml.

I think the migration should set the value in the database literally to textile (as Holger suggested) in case no setting is present, to persist the previous

default.

(Edit: Of course in that case Holger's second point, changing the create_settings migration in the same commit to reflect the new default for fresh

installations, is necessary as well)

#19 - 2022-07-13 12:29 - Marius BĂLTEANU

You're right Jens, I didn't see this point. Thanks both for your feedback on this.

I'm going to update the patches in the following days.

#20 - 2022-09-27 23:37 - Marius BĂLTEANU

- File 0001-Set-common_mark-as-default-text-formatting.diff added

I've updated the patch, I think now it covers both cases:

for existing installations, it explicit save the "textile" value in the database

for new installations, it set during the 017_create_settings.rb migration the value to Setting.text_formatting.

it adds a test to assert that the default value for new installations is "common_mark".

Jens, Holger, can you take a look on the patches, please? I would like a double check before committing this.

#21 - 2022-09-27 23:37 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

#22 - 2022-10-04 21:22 - Marius BĂLTEANU

- Status changed from New to Resolved

I've committed the change, please let me know if there are any issues.
#23 - 2022-10-05 03:00 - Go MAEDA

Since CommonMark is the default formatter now, commonmarker gem should not be optional. And since Redmine already does not support JRuby,

there is no need to set common_mark to optional in consideration of JRuby.

diff --git a/Gemfile b/Gemfile

index bccf76491..2d15ba953 100644

--- a/Gemfile

+++ b/Gemfile

@@ -48,11 +48,9 @@ group :markdown do

   gem 'redcarpet', '~> 3.5.1'

 end

-# Optional CommonMark support, not for JRuby

-group :common_mark do

-  gem "commonmarker", '0.23.4'

-  gem 'deckar01-task_list', '2.3.2'

-end

+# CommonMark support

+gem "commonmarker", '0.23.4'

+gem 'deckar01-task_list', '2.3.2'

 # Include database gems for the adapters found in the database

 # configuration file

#24 - 2022-10-14 10:55 - Go MAEDA

A test added in r21897 fails.

Error:

SettingTest#test_default_text_formatting_for_new_installations_is_common_mark:

NoMethodError: undefined method `value' for nil:NilClass

    assert_equal 'common_mark', Setting.find_by(:name => 'text_formatting').value

                                                                           ^^^^^^

    test/unit/setting_test.rb:151:in `test_default_text_formatting_for_new_installations_is_common_mark'

rails test test/unit/setting_test.rb:149

#25 - 2022-10-14 10:58 - Marius BĂLTEANU

- Status changed from Resolved to Reopened

#26 - 2022-11-13 02:25 - Ko Nagase

- File 0001-Add-settings-fixture-for-default-text_formatting.patch added

Go MAEDA wrote:

A test added in r21897 fails.

[...]

 About the above common mark test error, I confirmed that test env database doesn't have settings table record for "text_formatting" =>

"common_mark", while development env database has the record.

I upload settings fixture patch for test env, so reviewing it is helpful.

(Update) GitHub CI before/after results are here:

Before: https://github.com/sanak/redmine/actions/runs/3454800102

After: https://github.com/sanak/redmine/actions/runs/3454896967

#27 - 2023-02-23 22:15 - Holger Just

- Related to Feature #37365: Allow users to choose textile or markdown formatting added

#28 - 2023-10-08 01:51 - Go MAEDA

- Status changed from Reopened to Closed
Go MAEDA wrote in #note-24:

A test added in r21897 fails.

 Fixed in r21962.

Files

0001-Explicitly-specify-text-formatting-in-the-test-suite.patch 69.4 KB 2021-03-16 Go MAEDA

0002-Change-the-default-text-formatting-to-Markdown.patch 625 Bytes 2021-03-16 Go MAEDA

0003-Change-the-text-formatting-of-fixtures-to-Markdown.patch 13.3 KB 2021-03-16 Go MAEDA

0001-Set-common_mark-as-default-text-formatting.patch 1.23 KB 2022-05-17 Marius BĂLTEANU

0001-Set-common_mark-as-default-text-formatting.patch 1.83 KB 2022-06-25 Marius BĂLTEANU

0001-Set-common_mark-as-default-text-formatting.diff 3.34 KB 2022-09-27 Marius BĂLTEANU

0001-Add-settings-fixture-for-default-text_formatting.patch 1.04 KB 2022-11-13 Ko Nagase
